const Compiler = require("../src/compiler");
const Lexer = require("../src/lexer");
const Parser = require("../src/parser");

const scan = source => {
  const lexer = new Lexer();
  return lexer.scan(source);
};

const parse = source => {
  const parser = new Parser(scan(source));
  return parser.parse();
};

const compile = (source, context) => {
  const compiler = new Compiler(parse(source), context);
  return compiler.compile();
};

module.exports = {
  scan: scan,
  parse: parse,
  compile: compile
};
